LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;

entity accumulator_reg is
	port (
			clk, rst : in std_logic;
			instruction_reg: in std_logic_vector (4 downto 0);
			light_reg: in std_logic_vector (7 downto 0);
			selector: in std_logic_vector (2 downto 0);
			q: out std_logic_vector (7 downto 0));
end accumulator_reg;

architecture behavioral of accumulator_reg is
	signal a_reg : unsigned (7 downto 0);
begin
	action: process(clk, rst) begin
		if rst = '1' then a_reg <= "00000000";
		elsif clk = '1' and clk'event then
			case selector is 
			when "000" => if instruction_reg(4) = '0' then
								a_reg(3 downto 0) <= unsigned(instruction_reg(3 downto 0));
								a_reg(7 downto 4) <= a_reg(7 downto 4);
							else 
								a_reg(3 downto 0) <= a_reg(3 downto 0);
								a_reg(7 downto 4) <= unsigned(instruction_reg(3 downto 0));
							end if;
			when "001" => a_reg <= unsigned(light_reg);
			when "011" => a_reg <= not a_reg(7) & not a_reg(6) & not a_reg(5) & not a_reg(4) & 
								   not a_reg(3) & not a_reg(2) & not a_reg(1) & not a_reg(0);
			when "100" => a_reg <= a_reg + 1;
			when "101" => a_reg <= a_reg - 1;
			when "110" => a_reg <= a_reg(6 downto 0) & '0';
			when "111" => a_reg <= '0' & a_reg(7 downto 1);
			when others => a_reg <= a_reg;
			end case;
		end if;
	end process action;
	
	q <= std_logic_vector (a_reg);
end behavioral;

