library ieee;                           -- always include the ieee libraries
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity clockdivider is
	port(reset, clk: in std_logic;  -- reset and clock input signals
             clockbits: out std_logic_vector(7 downto 0));  -- output clock signals
end clockdivider;

architecture behavioral of clockdivider is
	signal counter: unsigned(23 downto 0);  -- big counter
begin
	process (clk) begin
		if reset = '1' then
			counter <= "000000000000000000000000";  -- on reset,
                                                                -- reset the clock
		elsif clk = '1' and clk'event then  -- otherwise, increment the
                                                    -- counter
			counter <= counter + 1;
		end if;
	end process;

	clockbits <= std_logic_vector(counter(23 downto 16));  -- connect the
                                                               -- counter with
                                                               -- the output
                                                               -- vector using
                                                               -- the type
                                                               -- casting function
end behavioral;


